import json
import ssl
import yaml
import pika

class sdtcloudamqp():
    def __init__(self):
        appId, deviceConfig, amqpUrl = self.getConfig()
        if appId == "":
            appId = "execution"

        self.host = amqpUrl
        self.port = 5671
        self.username = "sdt-cloud"
        self.password = "Sdt251327412287!"
        self.exchange = "sss"
        ssl_context = ssl.SSLContext(ssl.PROTOCOL_TLSv1_2)
        ssl_context.set_ciphers('ECDHE+AESGCM:!ECDSA')

        url = f'amqps://{username}:{password}@{host}:{port}'
        parameters = pika.URLParameters(url)
        parameters.ssl_options = pika.SSLOptions(context=ssl_context)
        self.__connection = pika.BlockingConnection(parameters)
        print(f'{url} connected.')
        self.__channel = self.__connection.channel()
        self.exchange

    def getConfig(self):

        with open('/etc/sdt/device.config/app.json', encoding='UTF-8') as f:
            appConfig = json.load(f)
        
        with open('./framework.yaml', encoding='UTF-8') as f:
            appFramework = yaml.load(f, Loader=yaml.FullLoader)
        
        appId = ""
        for appInfo in appConfig["AppInfoList"]:
            if appInfo["AppName"] == appFramework["spec"]["appName"]:
                appId = appInfo["AppId"]

        with open('/etc/sdt/device.config/config.json', encoding='UTF-8') as f:
            deviceConfig = json.load(f)
        
        amqpUrl = ""
        if deviceConfig["servicecode"] == "sdtcloud":
            amqpUrl = "b-48bdaf5e-d86c-4d3d-af46-219023b6481d.mq.ap-northeast-2.amazonaws.com"
        elif deviceConfig["servicecode"] == "sdtcloud-live":
            amqpUrl = "b-add8a3e8-ff21-4ddc-9174-0e81b89b28f6.mq.ap-northeast-2.amazonaws.com/"

        return appId, deviceConfig, amqpUrl
    

    def pubMessage(self, msg):
        payload = bytes(json.dumps(msg), 'utf-8')
        self.__channel.basic_publish(exchange=self.exchange, routing_key='', body=payload)
        print(f'exchange={self.exchange}, body={payload} published.')

    def __exit__(self, exc_type, exc_val, exc_tb):
        self.__channel.close()
        self.__connection.close()
        print(f'{self.__connection} closed.')